/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TDmDocumentation.TDmDocumentationPath;
import de.ship.db.tables.TDmTablegrp.TDmTablegrpPath;
import de.ship.db.tables.TDmTransfer.TDmTransferPath;
import de.ship.db.tables.records.TCoreStudyRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreStudy extends TableImpl<TCoreStudyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_study</code>
     */
    public static final TCoreStudy T_CORE_STUDY = new TCoreStudy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreStudyRecord> getRecordType() {
        return TCoreStudyRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_study.lastchange</code>.
     */
    public final TableField<TCoreStudyRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_study.pk</code>. id of study
     */
    public final TableField<TCoreStudyRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "id of study");

    /**
     * The column <code>common_dd.t_core_study.fk_element</code>. reference to
     * element in hierarchy
     */
    public final TableField<TCoreStudyRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "reference to element in hierarchy");

    /**
     * The column <code>common_dd.t_core_study.name</code>. simple name
     */
    public final TableField<TCoreStudyRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "simple name");

    /**
     * The column <code>common_dd.t_core_study.token_data</code>. short cut for
     * data schema to be used by synonym name
     */
    public final TableField<TCoreStudyRecord, String> TOKEN_DATA = createField(DSL.name("token_data"), SQLDataType.CLOB.nullable(false), this, "short cut for data schema to be used by synonym name");

    /**
     * The column <code>common_dd.t_core_study.token_config</code>. short cut
     * for config schema to be used by synonym name
     */
    public final TableField<TCoreStudyRecord, String> TOKEN_CONFIG = createField(DSL.name("token_config"), SQLDataType.CLOB.nullable(false), this, "short cut for config schema to be used by synonym name");

    /**
     * The column <code>common_dd.t_core_study.unique_name_prefix</code>. unique
     * study prefix like s1 for ship1
     */
    public final TableField<TCoreStudyRecord, String> UNIQUE_NAME_PREFIX = createField(DSL.name("unique_name_prefix"), SQLDataType.CLOB.nullable(false), this, "unique study prefix like s1 for ship1");

    /**
     * The column <code>common_dd.t_core_study.label</code>. label in shippie
     */
    public final TableField<TCoreStudyRecord, String> LABEL = createField(DSL.name("label"), SQLDataType.CLOB.nullable(false).defaultValue(DSL.field(DSL.raw("''::text"), SQLDataType.CLOB)), this, "label in shippie");

    /**
     * The column <code>common_dd.t_core_study.label_order</code>. order nr for
     * the label in shippie, highest nr = topmost 
     */
    public final TableField<TCoreStudyRecord, Integer> LABEL_ORDER = createField(DSL.name("label_order"), SQLDataType.INTEGER.nullable(false).defaultValue(DSL.field(DSL.raw("0"), SQLDataType.INTEGER)), this, "order nr for the label in shippie, highest nr = topmost ");

    private TCoreStudy(Name alias, Table<TCoreStudyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreStudy(Name alias, Table<TCoreStudyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_study</code> table reference
     */
    public TCoreStudy(String alias) {
        this(DSL.name(alias), T_CORE_STUDY);
    }

    /**
     * Create an aliased <code>common_dd.t_core_study</code> table reference
     */
    public TCoreStudy(Name alias) {
        this(alias, T_CORE_STUDY);
    }

    /**
     * Create a <code>common_dd.t_core_study</code> table reference
     */
    public TCoreStudy() {
        this(DSL.name("t_core_study"), null);
    }

    public <O extends Record> TCoreStudy(Table<O> path, ForeignKey<O, TCoreStudyRecord> childPath, InverseForeignKey<O, TCoreStudyRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_STUDY);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreStudyPath extends TCoreStudy implements Path<TCoreStudyRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreStudyPath(Table<O> path, ForeignKey<O, TCoreStudyRecord> childPath, InverseForeignKey<O, TCoreStudyRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreStudyPath(Name alias, Table<TCoreStudyRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreStudyPath as(String alias) {
            return new TCoreStudyPath(DSL.name(alias), this);
        }

        @Override
        public TCoreStudyPath as(Name alias) {
            return new TCoreStudyPath(alias, this);
        }

        @Override
        public TCoreStudyPath as(Table<?> alias) {
            return new TCoreStudyPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreStudyRecord, Integer> getIdentity() {
        return (Identity<TCoreStudyRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreStudyRecord> getPrimaryKey() {
        return Keys.PK_CORE_STUDY;
    }

    @Override
    public List<UniqueKey<TCoreStudyRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_STUDY_UNIQUE_NAME_PREFIX);
    }

    @Override
    public List<ForeignKey<TCoreStudyRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_STUDY__FK_STUDY_ELEMENT);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_CORE_STUDY__FK_STUDY_ELEMENT, null);

        return _tCoreElementHierarchy;
    }

    private transient TDmDocumentationPath _tDmDocumentation;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_documentation</code> table
     */
    public TDmDocumentationPath tDmDocumentation() {
        if (_tDmDocumentation == null)
            _tDmDocumentation = new TDmDocumentationPath(this, null, Keys.T_DM_DOCUMENTATION__FK_DM_DOCUMENTATION_STUDY.getInverseKey());

        return _tDmDocumentation;
    }

    private transient TDmTablegrpPath _tDmTablegrp;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_tablegrp</code> table
     */
    public TDmTablegrpPath tDmTablegrp() {
        if (_tDmTablegrp == null)
            _tDmTablegrp = new TDmTablegrpPath(this, null, Keys.T_DM_TABLEGRP__FK_STUDY_ID.getInverseKey());

        return _tDmTablegrp;
    }

    private transient TDmTransferPath _tDmTransfer;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_transfer</code> table
     */
    public TDmTransferPath tDmTransfer() {
        if (_tDmTransfer == null)
            _tDmTransfer = new TDmTransferPath(this, null, Keys.T_DM_TRANSFER__FK_DM_TRANSFER_STUDY.getInverseKey());

        return _tDmTransfer;
    }

    @Override
    public TCoreStudy as(String alias) {
        return new TCoreStudy(DSL.name(alias), this);
    }

    @Override
    public TCoreStudy as(Name alias) {
        return new TCoreStudy(alias, this);
    }

    @Override
    public TCoreStudy as(Table<?> alias) {
        return new TCoreStudy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStudy rename(String name) {
        return new TCoreStudy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStudy rename(Name name) {
        return new TCoreStudy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreStudy rename(Table<?> name) {
        return new TCoreStudy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudy where(Condition condition) {
        return new TCoreStudy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStudy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStudy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStudy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreStudy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreStudy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
